;###############################################################################
/* SaveLoad for LilBuilder

*/
;###############################################################################

SaveLoad_Export(){
	FileSelectFile, OutFile, S16, GuiScript.ahk, Save Output Script, AutoHotkey Script (*.ahk)
	IfNotEqual, ErrorLevel, 0, Return
	StringRight, chk, OutFile, 4                            ;??? why not splitPath?
	IfNotEqual, chk, .ahk
		OutFile = %OutFile%.ahk
	StringReplace, ProjFile, OutFile, .ahk, _Gui.ini, A     ;??? Project file extension could be .sgui/.lilb
	FileDelete, %OutFile%                                   
	FileDelete, %ProjFile%                                  ;??? issue warning to overwrite

	CtrlCount = 0
	TabCount = 0
	TabPageCount = 0
	SaveLoad_GetDiff(DiffW, DiffH)    ;??? see below
	
	;Probably GuiList & CtrlList shouldn't be created here. this is temporary.
	;builder provided order of guis and controls to create must be used.
	GuiList =
	CtrlList =
	ProjPNames := Project("AllPropertyNames")
	;loop for project
	Loop, Parse, ProjPNames, `n
	{
		IfEqual, A_LoopField,, Continue
		%A_LoopField% := Project(A_LoopField)
		CurrProp := %A_LoopField%
		IfNotEqual, A_LoopField, ListOfGuiHWND
			IniWrite, %CurrProp%, %ProjFile%, Project, %A_LoopField%
	}

	StringSplit, ListOfGuiHWND, ListOfGuiHWND, |        ;??? why not loop,parse
	;loop for Guis
	Loop, %ListOfGuiHWND0%
	{
		CurrGuiCount = %A_Index%
		GuiList = %GuiList%|%CurrGuiCount%                 ;??? should be new GUIID
		CurrGuiHWND := "ListOfGuiHWND" A_Index             ;??? ?
		CurrGuiHWND := %CurrGuiHWND%
		GuiPNames := Gui(CurrGuiHWND,"AllPropertyNames")
		Loop, Parse, GuiPNames, `n
		{
			IfEqual, A_LoopField,, Continue
			%A_LoopField% := Gui(CurrGuiHWND, A_LoopField)
			CurrProp := %A_LoopField%
			IfNotEqual, A_LoopField, OrderOfControls
				IniWrite, %CurrProp%, %ProjFile%, Gui %CurrGuiCount%, %A_LoopField%
			
			;loop for controls                                   ;??? use recursion
			IfEqual, A_LoopField, OrderOfControls
				Loop, Parse, CurrProp, |                           ;??? isn't it `n
				{
					IfEqual, A_LoopField,, Continue
					CtrlCount ++
					CtrlList = %CtrlList%|%CtrlCount%
					CtrlHWND = %A_LoopField%
					;Control_GetPosSizeOnGui(CtrlHWND, X, Y, W, H)
					ControlGetPos, X, Y, W, H,, ahk_id %CtrlHWND%
					X -= %DiffW%                                        ;??? use SysGet values
					Y -= %DiffH%
					Y += %DiffW%
					CtrlPNames := Control(CtrlHWND,"AllPropertyNames")
					
					Loop, Parse, CtrlPNames, `n
					{
						IfEqual, A_LoopField,, Continue
						%A_LoopField% := Control(CtrlHWND, A_LoopField)
						CurrProp := %A_LoopField%
						IfNotEqual, A_LoopField, BelongsTo
							IniWrite, %CurrProp%, %ProjFile%, Control %CtrlCount%, %A_LoopField%
					}
					IniWrite, %X%, %ProjFile%, Control %CtrlCount%, X
					IniWrite, %Y%, %ProjFile%, Control %CtrlCount%, Y
					IniWrite, %W%, %ProjFile%, Control %CtrlCount%, W
					IniWrite, %H%, %ProjFile%, Control %CtrlCount%, H

					;if its a Tab control, add all its controls
					IfEqual, Type, Tab                            ;??? use recursion
					{
						TabCtrl = Control %CtrlCount%
						TabCtrlHWND = %CtrlHWND%
						TabPageList =
						PageCounter = 0
						Loop, Parse, Content, |                     
						{
							IfEqual, A_LoopField,, Continue
							TabPageCount ++
							PageCounter ++
							TabPageCtrlHWND := TabCtrlHWND "T" PageCounter
							TabPageAllCtrlHWND := Tab_Page_GetAllCtrlHWND(TabPageCtrlHWND)
							TabPageList = %TabPageList%|%TabPageCount%
							;loop for controls
							;SOME CODE DUPLICATION ---- TO OPTIMIZE!!
							ThisTabPageCtrlList =
							Loop, Parse, TabPageAllCtrlHWND, |        ;??? use recursion
							{
								IfEqual, A_LoopField,, Continue
								CtrlCount ++
								
								ThisTabPageCtrlList = %ThisTabPageCtrlList%|%CtrlCount%
								CtrlHWND = %A_LoopField%
								
								;it'd be better if this line worked :(
								;Control_GetPosSizeOnGui(CtrlHWND, X, Y, W, H)
								ControlGetPos, X, Y, W, H,, ahk_id %CtrlHWND%
								X -= %DiffW%                                  ;??? use SysGet values
								Y -= %DiffH%
								Y += %DiffW%

								CtrlPNames := Control(CtrlHWND,"AllPropertyNames")
								
								Loop, Parse, CtrlPNames, `n
								{
									IfEqual, A_LoopField,, Continue
									%A_LoopField% := Control(CtrlHWND, A_LoopField)
									CurrProp := %A_LoopField%
									IfNotEqual, A_LoopField, BelongsTo
										IniWrite, %CurrProp%, %ProjFile%, Control %CtrlCount%, %A_LoopField%
								}
								IniWrite, %X%, %ProjFile%, Control %CtrlCount%, X
								IniWrite, %Y%, %ProjFile%, Control %CtrlCount%, Y
								IniWrite, %W%, %ProjFile%, Control %CtrlCount%, W
								IniWrite, %H%, %ProjFile%, Control %CtrlCount%, H
							}
							StringTrimLeft, ThisTabPageCtrlList, ThisTabPageCtrlList, 1
							IniWrite, %ThisTabPageCtrlList%, %ProjFile%, TabPage %TabPageCount%, CtrlList
						}
						StringTrimLeft, TabPageList, TabPageList, 1
						IniWrite, %TabPageList%, %ProjFile%, %TabCtrl%, TabPageList
					} 
				}

		}

		StringTrimLeft, CtrlList, CtrlList, 1
		IniWrite, %CtrlList%, %ProjFile%, Gui %CurrGuiCount%, CtrlList

		WinGetPos, X, Y, W, H, ahk_ID %CurrGuiHWND%
		WinGetTitle, GuiTitle, ahk_ID %CurrGuiHWND%      ;??? use Property
		;write gui size and pos info
		WinGetPos, X, Y, W, H, ahk_id %WinID%            ;??? What is WinID?
		W -= %DiffW%                                     ;??? use SysGet values
		W -= %DiffW%
		H -= %DiffH%
		IniWrite, %X%, %ProjFile%, Gui %CurrGuiCount%, X
		IniWrite, %Y%, %ProjFile%, Gui %CurrGuiCount%, Y
		IniWrite, % %GuiID%GuiWidth, %ProjFile%, Gui %CurrGuiCount%, W
		IniWrite, % %GuiID%GuiHeight, %ProjFile%, Gui %CurrGuiCount%, H
		IniWrite, %GuiTitle%, %ProjFile%, Gui %CurrGuiCount%, Title
	}

	StringTrimLeft, GuiList, GuiList, 1
	IniWrite, %GuiList%, %ProjFile%, Project, GuiList
	
	SaveLoad_FinalScript(OutFile)
	Run, %OutFile%
}



;??? can be replace with SysGet
;??? this should be gui specific
SaveLoad_GetDiff(ByRef W, ByRef H){
	Loop, 99 { 
		Gui %A_Index%:+LastFoundExist 
		If not WinExist() { 
			NewGuiID = %A_Index% 
			break 
		}Else If (A_Index = 99){ 
			MsgBox, 4112, Error in function, NO GUI ID was available. 
			Return 0   
		} 
	}

	DetectBak = %A_DetectHiddenWindows%
	DetectHiddenWindows, On
	Gui, %NewGuiID%:Show, w400 h300 Hide, StealerTempGUI
	Gui, %NewGuiID%:Default
	WinGetPos,,, WinW, WinH, StealerTempGUI
	Gui, %NewGuiID%:Destroy
	W = %WinW%
	W -= 400
	W /= 2
	H = %WinH%
	H -= 300
	DetectHiddenWindows, %DetectBak%
}


;###############################################################################

;Steal(copy) gui and open it as project
SaveLoad_StealImport(){
	Stealer(A_Temp "\Gui_Stealer.ini")
	SaveLoad_ReadProject(A_Temp "\Gui_Stealer.ini")
}


;function to read the project
SaveLoad_ReadProject(File = "", GuitoCreate = 0){
	IfEqual, File,
	{
		FileSelectFile, File, 1,, Open Project File, Project File (*.ini)
		IfNotEqual, ErrorLevel, 0, Return
	}
  ;read project options and react on them

  If GuitoCreate = 0
  {
     IniRead, GuiList, %File%, Project, GuiList, %A_Space%
     Loop, Parse, GuiList, |, A_Space
         SaveLoad_ReadGui(File, A_LoopField)
  }
  Else
    SaveLoad_ReadGui(File, GuitoCreate)
}


;function to create a gui
SaveLoad_ReadGui(File, GuiNumber){
  IniRead, GuiID, %File%, Gui %GuiNumber%, GuiID, 1
  If !GuiID
      MsgBox, Error, need GuiID

  Gui, %GuiID%: +LastFound                                    ;??? use GUI_Create()
  SaveLoad_SetVarGlobal("Gui" GuiID "_HWND", WinExist())

  ;read global gui options (e.g. Margin) and react on them

  IniRead, CtrlList, %File%, Gui %GuiNumber%, CtrlList, %A_Space%
  Loop, Parse, CtrlList, |, A_Space
      SaveLoad_ReadControl(File, GuiID, A_LoopField)

  ;read gui options and react on them

  ;show gui
  Items2Read = X|Y|W|H|AutoSize

  Loop, Parse, Items2Read, |
   IniRead, %A_LoopField%, %File%, Gui %GuiNumber%, %A_LoopField%, %A_Space%

  IniRead, Title, %File%, Gui %GuiNumber%, Title, Gui %GuiID%
  Pos := ( x ? " x" : "") x ( y ? " y" : "") y ( w ? " w" : "") w ( h ? " h" : "") h
  Gui, %GuiID%:Show, %Pos% %AutoSize%, %Title%
}

;function to create a control
SaveLoad_ReadControl(File, GuiID, CtrlNumber){
  IniRead, Type, %File%, Control %CtrlNumber%, Type, %A_Space%
  If !Type
      MsgBox, Error, need Type

  ;read control options (e.g. Font) and react on them
  Items2Read = Type|VarName|GLabel|Content|Options|X|Y|W|H|R

  Loop, Parse, Items2Read, |
     IniRead, %A_LoopField%, %File%, Control %CtrlNumber%, %A_LoopField%, %A_Space%

  ;Pos := ( x ? " x" : "") x ( y ? " y" : "") y ( w ? " w" : "") w ( h ? " h" : "") h ( r ? " r" : "") r
  ;Options .= ( VarName ? " v" : "") VarName ( GLabel ? " g" : "") GLabel

  ;SaveLoad_CreateControl(GuiID, Type, Pos " " Options, Content)
  GuiHWND := WinExist() + 0
  Control_CreateNew(Type, GuiHWND, 1, GuiID, Content, VarName, X, Y, W, H, Options)

  ;read control options, that can only be applied after creation and react on them

  If (Type = "Tab"){
    IniRead, TabPageList, %File%, Control %CtrlNumber%, TabPageList, %A_Space%
    Loop, Parse, TabPageList, |, A_Space
        SaveLoad_ReadTabPage(File, GuiID, A_Index, A_LoopField)
    Gui,%GuiID%:Tab
  }
}

;function to populate a tab page
SaveLoad_ReadTabPage(File, GuiID, TabID, TabPageNumber ){
  IniRead, CtrlList, %File%, TabPage %TabPageNumber%, CtrlList, %A_Space%
  Loop, Parse, CtrlList, |, A_Space
  {
     Gui,%GuiID%:Tab, %TabID%
     SaveLoad_ReadControl(File, GuiID, A_LoopField)
  }

}

;function to set a specific var as global
SaveLoad_SetVarGlobal(VarName, VarValue){
  global
  %VarName% = %VarValue%
}




;###############################################################################





SaveLoad_FinalScript(OutFile){

StringReplace, ProjFile, OutFile, .ahk, _Gui.ini, A
SplitPath, ProjFile, ProjFile

;===============================================================================	
FinalScript1 =
(	
;LB_BuildGui("Ini file path", [Gui ID])
;if Gui ID is not specified, all Guis in project are built
LB_BuildGui(A_ScriptDir "\%ProjFile%")       ;as single function call
;ListVars                       ;to test global vars of GUI
Return

10GuiClose:
  ExitApp
Return

)


FinalScript2 =                       ;??? put these in extra file?
(%	

;function to read the project
LB_BuildGui(File, GuitoCreate = 0){
  ;read project options and react on them
 
  If GuitoCreate = 0
  { 
     IniRead, GuiList, %File%, Project, GuiList, %A_Space%
     Loop, Parse, GuiList, |, A_Space
         LB_ReadGui(File, A_LoopField)
  }
  Else
    LB_ReadGui(File, GuitoCreate)

}

;function to create a gui
LB_ReadGui(File, GuiNumber){
  IniRead, GuiID, %File%, Gui %GuiNumber%, GuiID, 1
  If !GuiID
      MsgBox, Error, need GuiID

  Gui, %GuiID%: +LastFound
  LB_SetVarGlobal("Gui" GuiID "_HWND", WinExist())

  ;read global gui options (e.g. Margin) and react on them

  IniRead, CtrlList, %File%, Gui %GuiNumber%, CtrlList, %A_Space%
  Loop, Parse, CtrlList, |, A_Space
      LB_ReadControl(File, GuiID, A_LoopField)

  ;read gui options and react on them
 
  ;show gui
  Items2Read = X|Y|W|H|AutoSize

  Loop, Parse, Items2Read, |
   IniRead, %A_LoopField%, %File%, Gui %GuiNumber%, %A_LoopField%, %A_Space%

  IniRead, Title, %File%, Gui %GuiNumber%, Title, Gui %GuiID%
  Pos := ( x ? " x" : "") x ( y ? " y" : "") y ( w ? " w" : "") w ( h ? " h" : "") h
  Gui, %GuiID%:Show, %Pos% %AutoSize%, %Title%
}

;function to create a control
LB_ReadControl(File, GuiID, CtrlNumber){
  IniRead, Type, %File%, Control %CtrlNumber%, Type, %A_Space%
  If !Type
      MsgBox, Error, need Type
 
  ;read control options (e.g. Font) and react on them
  Items2Read = Type|VarName|GLabel|Content|Options|X|Y|W|H|R
 
  Loop, Parse, Items2Read, |
     IniRead, %A_LoopField%, %File%, Control %CtrlNumber%, %A_LoopField%, %A_Space%

  Pos := ( x ? " x" : "") x ( y ? " y" : "") y ( w ? " w" : "") w ( h ? " h" : "") h ( r ? " r" : "") r
  Options .= ( VarName ? " v" : "") VarName ( GLabel ? " g" : "") GLabel

  LB_CreateControl(GuiID, Type, Pos " " Options, Content)

  ;read control options, that can only be applied after creation and react on them

  If (Type = "Tab"){
    IniRead, TabPageList, %File%, Control %CtrlNumber%, TabPageList, %A_Space%
    Loop, Parse, TabPageList, |, A_Space
        LB_ReadTabPage(File, GuiID, A_Index, A_LoopField)
    Gui,%GuiID%:Tab
  }
}

;function to populate a tab page
LB_ReadTabPage(File, GuiID, TabID, TabPageNumber ){
  IniRead, CtrlList, %File%, TabPage %TabPageNumber%, CtrlList, %A_Space%
  Loop, Parse, CtrlList, |, A_Space
  {
     Gui,%GuiID%:Tab, %TabID%
     LB_ReadControl(File, GuiID, A_LoopField)
  }

}

;function to set a specific var as global
LB_SetVarGlobal(VarName, VarValue){
  global
  %VarName% = %VarValue%
}

;create a control in a global context
LB_CreateControl(GuiID, Type, Options, Content){
  global
  Gui, %GuiID%:Add, %Type%, %Options%, %Content%
}
)
;===============================================================================

FileDelete, %OutFile%
FileAppend, %FinalScript1%, %OutFile%
FileAppend, %FinalScript2%, %OutFile%
}
