;###############################################################################
/* Tab for LilBuilder

*/
;###############################################################################

Tab_vActiveTabPage(NewHWND=""){     ;HWND of tab page subcontrol that new controls get add to
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Else Return HWND
}

Tab_AddControl2Page(TabPageHWND, CtrlHWND){
  OrderOfControls := Control(TabPageHWND,"OrderOfControls") . "|" . CtrlHWND
  If InStr(OrderOfControls, "|") = 1                 ;remove first | if any
    StringTrimLeft, OrderOfControls, OrderOfControls, 1
  Control(TabPageHWND,"OrderOfControls",OrderOfControls)
}

;###############################################################################
;##################   Return ALL Control HWND on tab                                                   
;###############################################################################

;return a list of ALL Control HWND that belong to a tab
Tab_GetAllCtrlHWND(CtrlHWND){
  TabPages := Control(CtrlHWND,"Content")
  Loop, Parse, TabPages, |
      If (AllControlsOnPage := Tab_Page_GetAllCtrlHWND(CtrlHWND "T" A_Index))
          AllControlsOnTab .= "|" AllControlsOnPage
  Return SubStr(AllControlsOnTab,2)
}

;return a list of ALL Control HWND that belong to a tab page
Tab_Page_GetAllCtrlHWND(TabPageCtrlHWND){
  PageControls := Control(TabPageCtrlHWND,"OrderOfControls")
  Loop, Parse, PageControls, |
    {
      AllControlsOnPage .= "|" A_LoopField
      If ("Tab" = Control(A_LoopField,"Type"))
          If (AllControlsOnTab := Tab_GetAllCtrlHWND(A_LoopField))  ;recurse into tab control
              AllControlsOnPage .= "|" AllControlsOnTab
    }
  Return SubStr(AllControlsOnPage,2)
}

;###############################################################################
;##################   Return ALL Control HWND on tab that are visible                                                  
;###############################################################################

;return a list of Control HWND that belong to a tab, excluding controls on inactive tab pages
Tab_GetAllCtrlHWNDFromActivePages(GuiHWND, CtrlHWND){
  GuiID := Gui(GuiHWND,"GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControlGet, ActiveTab , %GuiID%:, %CtrlID%
  Return Tab_Page_GetAllCtrlHWNDFromActivePage(GuiHWND, CtrlHWND "T" ActiveTab)
}

;return a list of ALL Control HWND that belong to a tab page, excluding controls on inactive tab pages
Tab_Page_GetAllCtrlHWNDFromActivePage(GuiHWND,TabPageCtrlHWND){
  ActivePageControls := Control(TabPageCtrlHWND,"OrderOfControls")
  Loop, Parse, ActivePageControls, |
    {
      AllControlsOnPage .= "|" A_LoopField
      If ("Tab" = Control(A_LoopField,"Type"))
          If (AllControlsOnTab := Tab_GetAllCtrlHWNDFromActivePages(GuiHWND, A_LoopField)) ;recurse into tab control
              AllControlsOnPage .= "|" AllControlsOnTab
    }
  Return SubStr(AllControlsOnPage,2)
}

;###############################################################################
;##################   Delete ALL Controls on tab                                                  
;###############################################################################

;delete a tab control and all corols it holds 
Tab_DeleteItself(CtrlHWND){
  TabPages := Control(CtrlHWND,"Content")
  Loop, Parse, TabPages, |
    {
       Tab_Page_DeleteAllCtrl(CtrlHWND "T" A_Index)   ;delete controls on page
       Control(CtrlHWND "T" A_Index,"Remove")          ;delete tab page dictionary
    }
  Control_Delete(CtrlHWND)                             ;delete the tab control itself
}

Tab_Page_DeleteAllCtrl(TabPageCtrlHWND){
  PageControls := Control(TabPageCtrlHWND,"OrderOfControls")
  Loop, Parse, PageControls, |
      If ("Tab" = Control(A_LoopField,"Type"))          ;delete tab
          Tab_DeleteItself(A_LoopField)
      Else                                              ;delete all other controls
          Control_Delete(A_LoopField)
  Control(TabPageCtrlHWND,"OrderOfControls","","Clear")
}
